/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>
#include <amxmisc>

/* cmds:
*  amx_scrollmsg <msg> <freq. in sec.>
*/

new start_pos
new end_pos
new scroll_msg[384]
new display_msg[384]
new Float:x_pos
new length
new freqtime

#define SPEED 0.3

public motd_msg(){
	new a, i = 0
	for(a = start_pos; a < end_pos; ++a)
		display_msg[i++] = scroll_msg[a]
	display_msg[i] = 0
	if (end_pos < length)
		end_pos++
	if (x_pos > 0.35)
		x_pos -= 0.0063
	else {
		start_pos++
		x_pos = 0.35
	}
	set_hudmessage(200, 100, 0, x_pos, 0.90, 0, SPEED, SPEED, 0.05, 0.05, 2)
	show_hudmessage(0,display_msg)
}

public motd_msg_init(){
	end_pos = 1
	start_pos = 0
	x_pos = 0.65
	set_task( SPEED , "motd_msg",123,"",0,"a", length + 48)
	client_print(0,print_console,scroll_msg)
}

public set_scrollmsg(id,level,cid) {
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	remove_task(123) /* remove current messaging */
	read_argv(1,scroll_msg,380)
	new hostname[64]
	get_cvar_string("hostname",hostname,63)
	replace(scroll_msg,380,"%hostname%",hostname)
	length = strlen(scroll_msg)
	new mytime[32]
	read_argv(2,mytime,31)
	freqtime = str_to_num(mytime)
	if (freqtime > 0) {		
		new minimal = floatround((length + 48) * (SPEED + 0.1))
		if (freqtime < minimal)	{
			console_print(id,"Minimal frequency for this message is %d seconds",minimal)
			freqtime = minimal
		}
		console_print(id,"Scrolling message displaying frequency: %d:%02d minutes",
			freqtime/60,freqtime%60)
		set_task(float(freqtime),"motd_msg_init",123,"",0,"b")
	}
	else
		console_print(id,"Scrolling message disabled")
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Scrolling Message","0.8.6","default")
	register_concmd("amx_scrollmsg","set_scrollmsg",ADMIN_CFG,"<msg> <freq. in sec.>")
	return PLUGIN_CONTINUE
}

